#define maxn 100000
#define M 999999999

#include <stdio.h>
#include <math.h>
#include <algorithm>

using namespace std;

long long a[maxn], t[maxn], s;
int n, i;

inline long long large_rand(long long mod)
{
    return abs((((long long) rand()) * RAND_MAX + rand()) % mod);
}

int split(long long * start, long long * finish, long long pivot_val)
{
    int left = 0, right = finish - start - 1;
    for (int i = 0; i < finish - start; i++)
    {
        long long num = *(start + i);
        if (num < pivot_val)
        {
            t[left] = num;
            left++;
        } else
        {
            t[right] = num;
            right--;
        }
    }
    int pos = left;
    for (int i = pos; i < finish - start; i++)
        if (t[i] == pivot_val)
        {
            swap(t[pos], t[i]);
            pos++;
        }
    for (int i = 0; i < finish - start; i++)
        *(start + i) = t[i];
    return left + large_rand(pos - left);
}

long long select(long long * start, long long * finish, int order)
{
    int rand_place = large_rand(finish - start);
    long long val = *(start + rand_place);
    int pos = split(start, finish, val);
    if (pos < order)
        return select(start + pos + 1, finish, order - pos - 1);
    else if (pos > order)
        return select(start, start + pos, order);
    else
        return val;
}

void almost_sort(long long * start, long long * finish, long long * from)
{
    split(start, finish, select(start, finish, from - start));
    sort(from, finish);
}

int main()
{
    freopen("set.dat", "r", stdin);
    freopen("set.sol", "w", stdout);

    srand(2013);

    scanf("%d", &n);
    for (i = 0; i < n; i++)
        scanf("%d", &a[i]);

    almost_sort(a, a + n, a + max(0, (int) (n - ((log(M) / log(2) + 1) + 3))));

    s = 0;
    for (i = 0; i < n; i++)
        s += a[i];

    i = n;
    while (i > 0 && 2 * a[i - 1] >= s)
    {
        s -= a[i - 1];
        i--;
    }

    printf("%d\n", i);

    return 0;
}
